> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Create an event trigger

POST https://rest.test.zuora.com/events/event-triggers
Content-Type: application/json

When you create an event trigger, you must specify the base object and define the trigger condition.

### Specify the base object

Use `baseObject` field to specify which object to define a trigger on. You can define an event trigger on any of the following objects:
  
* Account
* AccountingCode
* AccountingPeriod
* Amendment
* BillingRun
* Contact
* CreditBalanceAdjustment
* CreditMemo
* CreditMemoApplication
* CreditMemoApplicationItem
* CreditMemoItem
* CreditMemoPart
* DebitMemo
* DebitMemoItem
* DeliveryAdjustment
* Feature
* Fulfillment
* Fund
* Invoice
* InvoiceAdjustment
* InvoiceItem
* InvoiceItemAdjustment
* JournalEntry
* JournalEntryItem
* Order
* OrderAction
* OrderLineItem
* Payment
* PaymentApplication
* PaymentMethod
* PaymentPart
* PaymentSchedule
* PaymentScheduleItem
* Product
* ProductFeature
* ProductRatePlan
* ProductRatePlanCharge
* ProductRatePlanChargeTier
* RatePlan
* RatePlanCharge
* RatePlanChargeTier
* RatingResult
* Refund
* RefundApplication
* RefundPart
* RevenueEvent
* RevenueEventItem
* RevenueSchedule
* RevenueScheduleItem
* Subscription
* SubscriptionChargeDeliverySchedule
* SubscriptionChargePriceInterval
* SubscriptionChargePriceIntervalTier
* SubscriptionOffer
* SubscriptionProductFeature
* TaxationItem
* UpdaterDetail
* Usage
* ValidityPeriodSummary
  
In addition to the above Zuora standard objects, you can also use custom objects as base objects for custom events.

#### Tenant level base objects and tenant level event triggers

Zuora identifies the following base objects and custom objects as the tenant level base objects:
  
* AccountingCode
* AccountingPeriod
* BillingRun
* Feature
* JournalEntry
* JournalEntryItem
* Product
* ProductFeature
* ProductRatePlan
* ProductRatePlanCharge
* ProductRatePlanChargeTier

Event triggers defined on tenant level base objects are tenant level event triggers. Notifications associated with tenant level events are system notifications.
  
**Note:** Tenant level event triggers and system notifications are only available in the default profile.

### Define the trigger condition

The `condition` field is a [JEXL](http://commons.apache.org/proper/commons-jexl/) expression that specifies when to trigger events. The expression can contain fields from the object that the trigger is defined on.

**Note:** The condition cannot contain fields from [data source](https://knowledgecenter.zuora.com/DC_Developers/M_Export_ZOQL) objects that are joined to the object that the trigger is defined on.

For example, the following condition causes an event to be triggered whenever an invoice is posted with an amount greater than 1000:

  ```changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0```

Where:

* `changeType` is a keyword that specifies the type of change that occurred to the Invoice object. For all objects, the supported values of `changeType` are `INSERT`, `UPDATE`,  and `DELETE`.
* `Invoice.Status` is the value of the Invoice object's `Status` field after the change occurred.
* `Invoice.Status_old` is the value of the Invoice object's `Status` field before the change occurred.

In the above example, the value of `baseObject` is `Invoice`.

#### Limitations

This event trigger has the following limitations:
  
* Base object values for Zuora standard objects are case sensitive. For example, `PaymentMethod` is correct, and `Paymentmethod` or `paymentmethod` is incorrect.
* Base object values for custom objects must be lowercase. For example, `default__vehicle`.
* The INSERT change type is not supported on RatePlan base objects.
* The INSERT change type is not supported on SubscriptionProductFeature base objects.
* When creating custom events, you cannot match fields of the RatePlanCharge object against constant values for the `condition` field. For example, the following condition will cause errors: `RatePlanCharge.ShippingProcessStatus__c == 'Shipping Confirmed'`, where `Shipping Confirmed` is a constant value.
* Fields on objects are case-sensitive. For example, `PaymentMethod.createdbyid` can result in errors. The correct format is `PaymentMethod.CreatedById`.
* A condition cannot contain fields from data source objects that are joined to the base object.
* Do not create duplicate events because they will be either merged or deleted. Zuora considers events that have the same trigger condition as duplicate events, regardless of event type names.

See [Custom Events](https://knowledgecenter.zuora.com/Central_Platform/Notifications/A_Z_Custom_Events) for more information.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/events-and-notifications/custom-event-triggers/post-event-trigger

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

### Body (application/json)

This endpoint expects a PostEventTriggerRequest.

- `active` (boolean, required) — The status of the event trigger.
- `baseObject` (string, required) — The base object that the trigger rule is defined upon. The format of the value in this field depends on the base object type: * Standard object: object name, which should follow the pattern ^\[A-Z]\[\w-]\*\$. For example, `Invoice`. * Custom object: `default__<custom_object_api_name>`. For example, `default__vehicle`.
- `condition` (string, required) — The JEXL expression to be evaluated against object changes. See above for more information and an example.
- `eventType` (EventType, required)
- `description` (string, optional) — The description of the event trigger.

## Response

### 200

OK

- `active` (boolean, optional) — The status of the trigger.
- `baseObject` (string, optional) — The base object that the trigger rule is defined upon. The format of the value in this field depends on the base object type: * Standard object: object name, which should follow the pattern ^\[A-Z]\[\w-]\*\$. For example, `Invoice`. * Custom object: `default__<custom_object_api_name>`. For example, `default__vehicle`.
- `condition` (string, optional) — The JEXL expression to be evaluated against object changes. See above for more information and an example.
- `description` (string, optional) — The description of the trigger.
- `eventType` (EventType, optional)
- `id` (string, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 500 Internal Server Error

Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

## Types

### EventType

- `displayName` (string, required) — The display name for the event type.
- `name` (string, required) — The name of the event. Should be unique, contain no space, and be in the pattern: ^\[A-Za-z]\{1,}\[\w\\-]\*\$
- `description` (string, optional) — The description of the event type.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "active": true,
  "baseObject": "Invoice",
  "condition": "changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0",
  "eventType": {
    "displayName": "Large Invoice Posted",
    "name": "LargeInvoicePosted"
  }
}
```

**Response**

```json
{
  "active": true,
  "baseObject": "Invoice",
  "condition": "changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0",
  "eventType": {
    "displayName": "Large Invoice Posted",
    "name": "LargeInvoicePosted",
    "namespace": "user.notification"
  },
  "id": "5a70564ad08c412fb98e06a80c365c93"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/events/event-triggers"

payload = {
    "active": True,
    "baseObject": "Invoice",
    "condition": "changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0",
    "eventType": {
        "displayName": "Large Invoice Posted",
        "name": "LargeInvoicePosted"
    }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/events/event-triggers';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"active":true,"baseObject":"Invoice","condition":"changeType == \'UPDATE\' && Invoice.Status == \'Posted\' && Invoice.Status_old != \'Posted\' && Invoice.Amount > 1000.0","eventType":{"displayName":"Large Invoice Posted","name":"LargeInvoicePosted"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/events/event-triggers"

	payload := strings.NewReader("{\n  \"active\": true,\n  \"baseObject\": \"Invoice\",\n  \"condition\": \"changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0\",\n  \"eventType\": {\n    \"displayName\": \"Large Invoice Posted\",\n    \"name\": \"LargeInvoicePosted\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/events/event-triggers")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"active\": true,\n  \"baseObject\": \"Invoice\",\n  \"condition\": \"changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0\",\n  \"eventType\": {\n    \"displayName\": \"Large Invoice Posted\",\n    \"name\": \"LargeInvoicePosted\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://rest.test.zuora.com/events/event-triggers")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"active\": true,\n  \"baseObject\": \"Invoice\",\n  \"condition\": \"changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0\",\n  \"eventType\": {\n    \"displayName\": \"Large Invoice Posted\",\n    \"name\": \"LargeInvoicePosted\"\n  }\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://rest.test.zuora.com/events/event-triggers', [
  'body' => '{
  "active": true,
  "baseObject": "Invoice",
  "condition": "changeType == \'UPDATE\' && Invoice.Status == \'Posted\' && Invoice.Status_old != \'Posted\' && Invoice.Amount > 1000.0",
  "eventType": {
    "displayName": "Large Invoice Posted",
    "name": "LargeInvoicePosted"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/events/event-triggers");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"active\": true,\n  \"baseObject\": \"Invoice\",\n  \"condition\": \"changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0\",\n  \"eventType\": {\n    \"displayName\": \"Large Invoice Posted\",\n    \"name\": \"LargeInvoicePosted\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "active": true,
  "baseObject": "Invoice",
  "condition": "changeType == 'UPDATE' && Invoice.Status == 'Posted' && Invoice.Status_old != 'Posted' && Invoice.Amount > 1000.0",
  "eventType": [
    "displayName": "Large Invoice Posted",
    "name": "LargeInvoicePosted"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/events/event-triggers")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```